class com.airtightinteractive.apps.viewers.simpleViewer.StageManager
{
   var mClip_mc;
   var mThumbArea;
   var mImageArea;
   var mXMLManager;
   var mBkgndLoaded;
   var mBkgnd_mc;
   var mCaption_mc;
   var mTitle_mc;
   var mDownloadLink_mc;
   var mcText;
   var mResize_int;
   static var instance;
   static var sResizeTime = 100;
   function StageManager()
   {
   }
   static function getInstance()
   {
      if(com.airtightinteractive.apps.viewers.simpleViewer.StageManager.instance == null)
      {
         com.airtightinteractive.apps.viewers.simpleViewer.StageManager.instance = new com.airtightinteractive.apps.viewers.simpleViewer.StageManager();
      }
      return com.airtightinteractive.apps.viewers.simpleViewer.StageManager.instance;
   }
   function init(target)
   {
      this.mClip_mc = target;
      this.mThumbArea = com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.getInstance();
      this.mImageArea = com.airtightinteractive.apps.viewers.simpleViewer.ImageArea.getInstance();
      this.mXMLManager = com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.getInstance();
      this.mXMLManager.xmlData = _global.gImageData_xml;
      var _loc3_ = new ContextMenu();
      _loc3_.hideBuiltInItems();
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.enableDownloadLink)
      {
         _loc3_.customItems.push(new ContextMenuItem("Download SimpleViewer",this.openURL));
      }
      this.mClip_mc.menu = _loc3_;
      this.mBkgndLoaded = false;
   }
   function onXMLLoaded()
   {
      if(this.mXMLManager.backgroundImagePath != null)
      {
         this.mBkgnd_mc = this.mClip_mc.createEmptyMovieClip("mcBkgnd",this.mClip_mc.getNextHighestDepth());
         var _loc3_ = new MovieClipLoader();
         _loc3_.addListener(this);
         _loc3_.loadClip(this.mXMLManager.backgroundImagePath,this.mBkgnd_mc);
      }
      this.mImageArea.init(this.mClip_mc);
      this.mThumbArea.init(this.mClip_mc);
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.showCaptions && this.mThumbArea.pageSize > 0)
      {
         this.mCaption_mc = this.mClip_mc.attachMovie("Caption","mcCaption",this.mClip_mc.getNextHighestDepth());
         if(!com.airtightinteractive.apps.viewers.simpleViewer.Options.fixedLayout)
         {
            this.mCaption_mc.txtText.autoSize = true;
         }
         this.mCaption_mc.txtText.wordWrap = true;
         var _loc5_ = new Color(this.mCaption_mc);
         _loc5_.setRGB(this.mXMLManager.captionTextColor);
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.showTitle && this.mThumbArea.pageSize > 0)
      {
         this.mTitle_mc = this.mClip_mc.attachMovie("Title","mcTitle",this.mClip_mc.getNextHighestDepth());
         if(!com.airtightinteractive.apps.viewers.simpleViewer.Options.fixedLayout)
         {
            this.mTitle_mc.txtText.autoSize = true;
         }
         this.mTitle_mc.txtText.wordWrap = true;
         this.mTitle_mc.txtText.htmlText = this.mXMLManager.title;
         var _loc4_ = new Color(this.mTitle_mc);
         _loc4_.setRGB(this.mXMLManager.titleTextColor);
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.enableDownloadLink)
      {
         this.mDownloadLink_mc = this.mClip_mc.attachMovie("DownloadLink","mcDownloadLink",this.mClip_mc.getNextHighestDepth());
         this.mDownloadLink_mc.onRollOver = function()
         {
            this.mcText.gotoAndPlay(2);
         };
         this.mDownloadLink_mc.onRollOut = function()
         {
            this.mcText.gotoAndStop(1);
         };
         this.mDownloadLink_mc.onRelease = mx.utils.Delegate.create(this,this.openURL);
         var _loc2_ = new Color(this.mDownloadLink_mc.mcText);
         _loc5_ = new Color(this.mDownloadLink_mc.mcBkgnd);
         _loc2_.setRGB(this.mXMLManager.captionTextColor);
         if(_loc2_.getRGB() < 6710886)
         {
            _loc5_.setRGB(16777215);
         }
      }
      if(!com.airtightinteractive.apps.viewers.simpleViewer.Options.fixedLayout)
      {
         Stage.addListener(this);
      }
      this.doLayout();
      this.mImageArea.createImages();
      this.mThumbArea.createThumbs();
   }
   function doLayout()
   {
      clearInterval(this.mResize_int);
      this.mResize_int = null;
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.fixedLayout)
      {
         this.mThumbArea.setPosn(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbAreaX,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbAreaY);
         this.mImageArea.setPosn(com.airtightinteractive.apps.viewers.simpleViewer.Options.imageAreaX,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageAreaY);
         this.mImageArea.setSize(com.airtightinteractive.apps.viewers.simpleViewer.Options.imageAreaWidth,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageAreaHeight);
         this.mCaption_mc._x = com.airtightinteractive.apps.viewers.simpleViewer.Options.captionX;
         this.mCaption_mc._y = com.airtightinteractive.apps.viewers.simpleViewer.Options.captionY;
         this.mCaption_mc.txtText._width = com.airtightinteractive.apps.viewers.simpleViewer.Options.captionWidth;
         this.mCaption_mc.txtText._height = com.airtightinteractive.apps.viewers.simpleViewer.Options.captionHeight;
         this.mTitle_mc._x = com.airtightinteractive.apps.viewers.simpleViewer.Options.titleX;
         this.mTitle_mc._y = com.airtightinteractive.apps.viewers.simpleViewer.Options.titleY;
         this.mTitle_mc.txtText._width = com.airtightinteractive.apps.viewers.simpleViewer.Options.titleWidth;
         this.mTitle_mc.txtText._height = com.airtightinteractive.apps.viewers.simpleViewer.Options.titleHeight;
         this.mDownloadLink_mc._x = com.airtightinteractive.apps.viewers.simpleViewer.Options.downLoadLinkX;
         this.mDownloadLink_mc._y = com.airtightinteractive.apps.viewers.simpleViewer.Options.downloadLinkY;
      }
      else
      {
         var _loc4_ = Stage.width;
         var _loc3_ = Stage.height;
         if(_global.SVStageWidth != undefined)
         {
            _loc4_ = _global.SVStageWidth;
         }
         if(_global.SVStageHeight != undefined)
         {
            _loc3_ = _global.SVStageHeight;
         }
         var _loc5_ = undefined;
         var _loc6_ = undefined;
         var _loc13_ = undefined;
         var _loc11_ = undefined;
         var _loc9_ = undefined;
         var _loc7_ = undefined;
         var _loc10_ = undefined;
         var _loc12_ = undefined;
         var _loc8_ = this.mThumbArea.height;
         if(this.mXMLManager.navPosition == "top" || this.mXMLManager.navPosition == "bottom")
         {
            _loc8_ += this.mThumbArea.navHeight;
         }
         if(com.airtightinteractive.apps.viewers.simpleViewer.Options.enableImageDownScaling)
         {
            if(this.mXMLManager.navPosition == "right" || this.mXMLManager.navPosition == "left")
            {
               _loc6_ = Math.min(_loc4_ - this.mXMLManager.stagePadding * 3 - this.mThumbArea.width,this.mXMLManager.maxImageWidth + this.mXMLManager.frameWidth * 2);
               _loc5_ = Math.min(_loc3_ - this.mXMLManager.stagePadding * 2,this.mXMLManager.maxImageHeight + this.mXMLManager.frameWidth * 2);
            }
            else
            {
               _loc5_ = Math.min(_loc3_ - this.mXMLManager.stagePadding * 3 - _loc8_,this.mXMLManager.maxImageHeight + this.mXMLManager.frameWidth * 2);
               _loc6_ = Math.min(_loc4_ - this.mXMLManager.stagePadding * 2,this.mXMLManager.maxImageWidth + this.mXMLManager.frameWidth * 2);
            }
         }
         else
         {
            _loc6_ = this.mXMLManager.maxImageWidth;
            _loc5_ = this.mXMLManager.maxImageHeight;
         }
         _loc10_ = _loc6_ + this.mXMLManager.stagePadding + this.mThumbArea.width;
         _loc12_ = _loc5_ + this.mXMLManager.stagePadding + _loc8_;
         switch(this.mXMLManager.navPosition)
         {
            case "left":
               _loc13_ = (_loc4_ - _loc10_) / 2 + this.mThumbArea.width + this.mXMLManager.stagePadding;
               _loc11_ = (_loc3_ - _loc5_) / 2;
               _loc9_ = (_loc4_ - _loc10_) / 2;
               _loc7_ = (_loc3_ - _loc8_) / 2;
               break;
            case "right":
               _loc13_ = (_loc4_ - _loc10_) / 2;
               _loc11_ = (_loc3_ - _loc5_) / 2;
               _loc9_ = (_loc4_ - _loc10_) / 2 + _loc6_ + this.mXMLManager.stagePadding;
               _loc7_ = (_loc3_ - _loc8_) / 2;
               break;
            case "top":
               _loc13_ = (_loc4_ - _loc6_) / 2;
               _loc11_ = (_loc3_ - _loc12_) / 2 + _loc8_ + this.mXMLManager.stagePadding;
               _loc9_ = (_loc4_ - this.mThumbArea.width) / 2;
               _loc7_ = (_loc3_ - _loc12_) / 2;
               break;
            case "bottom":
               _loc13_ = (_loc4_ - _loc6_) / 2;
               _loc11_ = (_loc3_ - _loc12_) / 2;
               _loc9_ = (_loc4_ - this.mThumbArea.width) / 2;
               _loc7_ = (_loc3_ - _loc12_) / 2 + _loc5_ + this.mXMLManager.stagePadding;
         }
         this.mImageArea.setSize(_loc6_,_loc5_);
         this.mImageArea.setPosn(_loc13_,_loc11_);
         this.mThumbArea.setPosn(_loc9_,_loc7_);
         this.mCaption_mc.txtText._width = this.mThumbArea.width;
         this.mCaption_mc._x = _loc9_;
         this.mCaption_mc._y = _loc7_ + this.mThumbArea.height + this.mThumbArea.navHeight + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding;
         this.mTitle_mc.txtText._width = this.mThumbArea.width;
         this.mTitle_mc._x = _loc9_;
         this.mTitle_mc._y = _loc7_ - (com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding + this.mTitle_mc.txtText.textHeight);
         this.mDownloadLink_mc._x = Math.floor(_loc4_ - this.mDownloadLink_mc._width - 10);
         this.mDownloadLink_mc._y = Math.floor(_loc3_ - this.mDownloadLink_mc._height - 10);
         this.resizeBkgnd();
      }
   }
   function showCaption(index)
   {
      var _loc2_ = this.mXMLManager.imageCaptions[index];
      if(_loc2_ == undefined)
      {
         _loc2_ = "";
      }
      this.mCaption_mc.txtText.htmlText = _loc2_;
   }
   function openURL()
   {
      getURL(com.airtightinteractive.apps.viewers.simpleViewer.Options.linkURL,"_blank");
   }
   function onResize()
   {
      if(this.mResize_int == null)
      {
         this.mResize_int = setInterval(mx.utils.Delegate.create(this,this.doLayout),com.airtightinteractive.apps.viewers.simpleViewer.StageManager.sResizeTime);
      }
   }
   function onLoadInit()
   {
      this.mBkgndLoaded = true;
      this.resizeBkgnd();
   }
   function resizeBkgnd()
   {
      if(this.mXMLManager.backgroundImagePath != null && this.mBkgndLoaded && !com.airtightinteractive.apps.viewers.simpleViewer.Options.fixedLayout)
      {
         this.mBkgnd_mc._width = Stage.width;
         this.mBkgnd_mc._height = Stage.height;
      }
   }
}
