class com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea
{
   var mClip_mc;
   var mStageManager;
   var mXMLManager;
   var mRows;
   var mColumns;
   var mPageSize;
   var mFirstIndexDisplayed;
   var mSelectedThumbIndex;
   var mLastIndexDisplayed;
   var mDisplayAreaGotoX;
   var mWidth;
   var mHeight;
   var mNextBtn;
   var mBackBtn;
   var mPagingTwn;
   var mThumbs;
   static var instance;
   function ThumbArea()
   {
   }
   static function getInstance()
   {
      if(com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.instance == null)
      {
         com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.instance = new com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea();
      }
      return com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.instance;
   }
   function init(target)
   {
      this.mClip_mc = target.createEmptyMovieClip("thumbarea",target.getNextHighestDepth());
      this.mStageManager = com.airtightinteractive.apps.viewers.simpleViewer.StageManager.getInstance();
      this.mXMLManager = com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.getInstance();
      this.mRows = this.mXMLManager.thumbnailRows;
      this.mColumns = this.mXMLManager.thumbnailColumns;
      this.mPageSize = this.mRows * this.mColumns;
      this.mFirstIndexDisplayed = 0;
      this.mSelectedThumbIndex = 0;
      this.mLastIndexDisplayed = this.mPageSize;
      this.mDisplayAreaGotoX = 0;
      this.mWidth = (com.airtightinteractive.apps.viewers.simpleViewer.Thumb.thumbWidth + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding) * this.mColumns;
      this.mHeight = (com.airtightinteractive.apps.viewers.simpleViewer.Thumb.thumbHeight + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding) * this.mRows - com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding;
      Key.addListener(this);
      Mouse.addListener(this);
      if(this.mPageSize == 0)
      {
         return undefined;
      }
      if(this.mXMLManager.imageCount > this.mPageSize)
      {
         this.mClip_mc.attachMovie("ThumbNextButton","mcNextBtn",this.mClip_mc.getNextHighestDepth());
         this.mNextBtn = new com.airtightinteractive.apps.viewers.simpleViewer.RolloverButton(this.mClip_mc.mcNextBtn);
         this.mNextBtn.doAction = mx.utils.Delegate.create(this,this.showNextPage);
         this.mClip_mc.attachMovie("ThumbBackButton","mcBackBtn",this.mClip_mc.getNextHighestDepth());
         this.mBackBtn = new com.airtightinteractive.apps.viewers.simpleViewer.RolloverButton(this.mClip_mc.mcBackBtn);
         this.mBackBtn.doAction = mx.utils.Delegate.create(this,this.showPreviousPage);
         if(com.airtightinteractive.apps.viewers.simpleViewer.Options.fixedLayout)
         {
            this.mBackBtn.setPosn(com.airtightinteractive.apps.viewers.simpleViewer.Options.backThumbArrowX,com.airtightinteractive.apps.viewers.simpleViewer.Options.backThumbArrowY);
            this.mNextBtn.setPosn(com.airtightinteractive.apps.viewers.simpleViewer.Options.nextThumbArrowX,com.airtightinteractive.apps.viewers.simpleViewer.Options.nextThumbArrowY);
         }
         else
         {
            this.mBackBtn.setPosn(0,this.mHeight);
            this.mNextBtn.setPosn(this.mWidth - (com.airtightinteractive.apps.viewers.simpleViewer.Thumb.thumbWidth + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding),this.mHeight);
         }
         this.mBackBtn.clickShift = 1;
         this.mNextBtn.clickShift = 1;
         this.mNextBtn.hideOnRollOut = false;
         this.mBackBtn.hideOnRollOut = false;
         this.mBackBtn.setRGB(this.mXMLManager.pagingArrowsColor);
         this.mNextBtn.setRGB(this.mXMLManager.pagingArrowsColor);
      }
      this.mClip_mc.createEmptyMovieClip("mcDisplayMask",this.mClip_mc.getNextHighestDepth());
      this.mClip_mc.mcDisplayMask.beginFill(16776960,100);
      var _loc3_ = this.mWidth - com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.selectedFrameOffset * 2;
      var _loc2_ = this.mHeight + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.selectedFrameOffset * 2;
      com.airtightinteractive.util.RectUtil.rectangle(this.mClip_mc.mcDisplayMask,- com.airtightinteractive.apps.viewers.simpleViewer.Thumb.selectedFrameOffset,- com.airtightinteractive.apps.viewers.simpleViewer.Thumb.selectedFrameOffset,_loc3_,_loc2_);
      this.mClip_mc.mcDisplayMask.endFill();
      this.mClip_mc.createEmptyMovieClip("mcDisplayArea",this.mClip_mc.getNextHighestDepth());
      this.mClip_mc.mcDisplayArea.createEmptyMovieClip("mcSlidingDisplayArea",this.mClip_mc.mcDisplayArea.getNextHighestDepth());
      this.mClip_mc.mcDisplayArea.setMask(this.mClip_mc.mcDisplayMask);
      this.mPagingTwn = new mx.transitions.Tween(this.mClip_mc.mcDisplayArea.mcSlidingDisplayArea,"_x",mx.transitions.easing.Strong.easeOut,0,0,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailMotionLength,false);
   }
   function createThumbs()
   {
      this.mThumbs = [];
      var _loc2_ = 0;
      while(_loc2_ <= this.mXMLManager.imageCount - 1)
      {
         this.mThumbs[_loc2_] = new com.airtightinteractive.apps.viewers.simpleViewer.Thumb(this.mClip_mc.mcDisplayArea.mcSlidingDisplayArea,_loc2_,this.mXMLManager.thumbPath + this.mXMLManager.imageFileNames[_loc2_]);
         var _loc3_ = Math.floor(_loc2_ / (this.mColumns * this.mRows));
         var _loc5_ = _loc2_ % this.mColumns;
         var _loc4_ = Math.floor((_loc2_ - _loc3_ * this.pageSize) / this.mColumns);
         this.mThumbs[_loc2_].setPosn((com.airtightinteractive.apps.viewers.simpleViewer.Thumb.thumbWidth + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding) * _loc5_ + this.mWidth * _loc3_,(com.airtightinteractive.apps.viewers.simpleViewer.Thumb.thumbHeight + com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding) * _loc4_);
         _loc2_ = _loc2_ + 1;
      }
      this.updateNav();
      this.mThumbs[0].loadThumb();
   }
   function showIndex(index, instantTween)
   {
      var _loc2_ = Math.floor(index / this.mPageSize);
      this.mDisplayAreaGotoX = (- this.mWidth) * _loc2_;
      var _loc3_ = !instantTween ? com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailMotionLength : 1;
      this.mPagingTwn.continueTo(this.mDisplayAreaGotoX,_loc3_);
      this.mFirstIndexDisplayed = this.mPageSize * _loc2_;
      this.updateNav();
   }
   function updateNav()
   {
      this.mLastIndexDisplayed = this.mFirstIndexDisplayed + this.mPageSize;
      this.mBackBtn.visible = this.mFirstIndexDisplayed > 0;
      this.mNextBtn.visible = this.mLastIndexDisplayed < this.mXMLManager.imageCount;
   }
   function showNextPage()
   {
      this.mFirstIndexDisplayed += this.mPageSize;
      this.mDisplayAreaGotoX -= this.mWidth;
      this.mPagingTwn.continueTo(this.mDisplayAreaGotoX,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailMotionLength);
      this.updateNav();
   }
   function showPreviousPage()
   {
      this.mFirstIndexDisplayed -= this.mPageSize;
      if(this.mFirstIndexDisplayed < 1)
      {
         this.mFirstIndexDisplayed = 0;
      }
      this.mDisplayAreaGotoX += this.mWidth;
      this.mPagingTwn.continueTo(this.mDisplayAreaGotoX,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailMotionLength);
      this.updateNav();
   }
   function showImageProgress(index, percent)
   {
      this.mThumbs[index].showImageProgress(percent);
   }
   function showImageLoadComplete(index)
   {
      this.mThumbs[index].showImageLoadComplete();
      if(index == this.mSelectedThumbIndex)
      {
         this.mThumbs[index].select();
      }
   }
   function set selectedThumbIndex(index)
   {
      if(index < 0)
      {
         return;
      }
      if(index >= this.mXMLManager.imageCount)
      {
         return;
      }
      if(index == this.mSelectedThumbIndex)
      {
         return;
      }
      this.mThumbs[this.mSelectedThumbIndex].unselect();
      this.mSelectedThumbIndex = index;
      this.mThumbs[index].select();
      if(this.mSelectedThumbIndex < this.mFirstIndexDisplayed)
      {
         this.showIndex(this.mSelectedThumbIndex,false);
      }
      else if(this.mSelectedThumbIndex >= this.mLastIndexDisplayed)
      {
         this.showIndex(this.mSelectedThumbIndex,false);
      }
   }
   function get selectedThumbIndex()
   {
      return this.mSelectedThumbIndex;
   }
   function get pageSize()
   {
      return this.mPageSize;
   }
   function setPosn(x, y)
   {
      x = Math.round(x);
      y = Math.round(y);
      this.mClip_mc._x = x;
      this.mClip_mc._y = y;
   }
   function onKeyDown()
   {
      if(Key.isDown(37))
      {
         this.selectedThumbIndex = this.selectedThumbIndex - 1;
      }
      else if(Key.isDown(39))
      {
         this.selectedThumbIndex = this.selectedThumbIndex + 1;
      }
      else if(Key.isDown(38))
      {
         this.selectedThumbIndex -= this.mColumns;
      }
      else if(Key.isDown(40))
      {
         this.selectedThumbIndex += this.mColumns;
      }
      else if(Key.isDown(36))
      {
         this.selectedThumbIndex = 0;
      }
      else if(Key.isDown(35))
      {
         this.selectedThumbIndex = this.mXMLManager.imageCount - 1;
      }
      else if(Key.isDown(33))
      {
         this.selectedThumbIndex -= this.mPageSize;
      }
      else if(Key.isDown(34))
      {
         this.selectedThumbIndex += this.mPageSize;
      }
   }
   function onMouseWheel(delta)
   {
      if(delta > 0)
      {
         this.selectedThumbIndex = this.selectedThumbIndex - 1;
      }
      else
      {
         this.selectedThumbIndex = this.selectedThumbIndex + 1;
      }
   }
   function toString()
   {
      return "thumbArea";
   }
   function get width()
   {
      return this.mWidth - com.airtightinteractive.apps.viewers.simpleViewer.Thumb.padding;
   }
   function get height()
   {
      return this.mHeight;
   }
   function get navHeight()
   {
      if(this.mXMLManager.imageCount <= this.mPageSize || this.mPageSize == 0)
      {
         return 0;
      }
      return com.airtightinteractive.apps.viewers.simpleViewer.Thumb.thumbHeight;
   }
   function loadNextThumb(index)
   {
      var _loc2_ = index + 1;
      this.mThumbs[_loc2_].loadThumb();
   }
}
